<html xmlns="https://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta http-equiv="Content-Language" content="zh-CN" />
<link href="../style/css/manual-zip.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="../style/css/manual-zip-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="../style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" />
<meta name="description" content="mod_authn_dbd － Apache 2.2 中文手册 [金步国作品集]">
<title>mod_authn_dbd － Apache 2.2 中文手册 [金步国]</title>
<script> var _hmt = _hmt || []; (function() { var hm = document.createElement("script"); hm.src = "https://hm.baidu.com/hm.js?2468a2c5d539e359902070bcd91865b1"; var s = document.getElementsByTagName("script")[0]; s.parentNode.insertBefore(hm, s); })(); </script>
</head>
<body><div id="page-header">
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p><p class="apache">Apache HTTP Server 版本2.2</p><img alt="" src="../images/feather.gif" /></div>
<div class="up"><a href="./index.html"><img title="&lt;-" alt="&lt;-" src="../images/left.gif" /></a></div>
<div id="path"><a href="https://www.apache.org/">Apache</a> &gt; <a href="https://httpd.apache.org/">HTTP Server</a> &gt; <a href="https://httpd.apache.org/docs/">文档</a> &gt; <a href="../index.html">版本2.2</a> &gt; <a href="./index.html">模块</a></div>

<div id="translation-info">　　 <a href="../translator_announcement.html#thanks">致谢</a> | 本篇译者：<a href="https://www.jinbuguo.com/">金步国</a>(<a href="https://www.jinbuguo.com/">作品集</a>) | 本页最后更新：2006年10月20日</div>
<div id="page-content"><div id="preamble"><h1>Apache模块 mod_authn_dbd</h1>

<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="module">
<tr><th><a href="module-dict.html#Description">说明</a></th><td>使用SQL数据库为认证提供支持</td></tr>
<tr><th><a href="module-dict.html#Status">状态</a></th><td>扩展(E)</td></tr>
<tr><th><a href="module-dict.html#ModuleIdentifier">模块名</a></th><td>authn_dbd_module</td></tr>
<tr><th><a href="module-dict.html#SourceFile">源文件</a></th><td>mod_authn_dbd.c</td></tr>
<tr><th><a href="module-dict.html#Compatibility">兼容性</a></th><td>仅在 Apache 2.1 及以后的版本中可用</td></tr>
</table>
<h3>概述</h3>

    <p>该模块为认证前端(<code class="module"><a href="../mod/mod_auth_digest.html">mod_auth_digest</a></code>和<code class="module"><a href="../mod/mod_auth_basic.html">mod_auth_basic</a></code>)使用SQL数据库进行用户认证提供支持。<code class="module"><a href="../mod/mod_authn_file.html">mod_authn_file</a></code>模块也提供类似的功能。</p>
    <p>本模块依赖于<code class="module"><a href="../mod/mod_dbd.html">mod_dbd</a></code>指定的后端数据库驱动程序和连接参数以及管理数据库连接。</p>
    <p>使用<code class="module"><a href="../mod/mod_auth_basic.html">mod_auth_basic</a></code>或<code class="module"><a href="../mod/mod_auth_digest.html">mod_auth_digest</a></code>的时候，可以通过在<code class="directive"><a href="../mod/mod_auth_basic.html#authbasicprovider">AuthBasicProvider</a></code>或<code class="directive"><a href="../mod/mod_auth_digest.html#authdigestprovider">AuthDigestProvider</a></code>指令中使用<code>dbd</code>值调用该模块。</p>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="example" id="example">配置示例</a></h2>

<p>下面这个简单的示例展示了如何在基于DBD框架的认证环境中使用该模块。</p>
<div class="example"><pre>
#数据库管理

#使用PostgreSQL驱动程序
<code>DBDriver pgsql</code>

#连接字符串：数据库名 用户名 密码
<code>DBDParams "dbname=htpasswd user=apache password=xxxxxx"</code>

#管理连接池的参数
<code>DBDMin  1
DBDKeep 2
DBDMax  10
DBDExptime 60</code>

#认证部分
<code>&lt;Directory /usr/www/myhost/private&gt;</code>

    #基于authn_dbd的认证配置
    <code>AuthType Basic
    AuthName "My Server"
    AuthBasicProvider dbd</code>

    #授权配置
    <code>Require valid-user</code>

    #验证用户的SQL查询语句
    #(注意：DBD驱动程序同时允许stdio风格的 %s 和特定于数据库的语法)
    <code>AuthDBDUserPWQuery "select password from authn where username = %s"
&lt;/Directory&gt;</code>
</pre></div>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="AuthDBDUserPWQuery" id="AuthDBDUserPWQuery">AuthDBDUserPWQuery</a> <a name="authdbduserpwquery" id="authdbduserpwquery">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>检索用户密码的SQL查询语句</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>AuthDBDUserPWQuery <var>query</var></code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>directory</td></tr>
<tr><th><a href="directive-dict.html#Override">覆盖项</a></th><td>AuthConfig</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>扩展(E)</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td>mod_authn_dbd</td></tr>
</table>
    <p><code class="directive">AuthDBDUserPWQuery</code>指定了从数据库中检索用户密码的SQL查询语句。该查询语句必须接受一个单独的字符串(通常是SQL里的varchar类型)参数(username)，同时返回一个单独的字符串值(hash过的密码)。</p>
    <div class="example"><p><code>AuthDBDUserPWQuery "SELECT password FROM authn WHERE username = %s"</code></p></div>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="AuthDBDUserRealmQuery" id="AuthDBDUserRealmQuery">AuthDBDUserRealmQuery</a> <a name="authdbduserrealmquery" id="authdbduserrealmquery">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>为用户名与认证区域的组合检索密码的SQL查询语句</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>AuthDBDUserRealmQuery <var>query</var></code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>directory</td></tr>
<tr><th><a href="directive-dict.html#Override">覆盖项</a></th><td>AuthConfig</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>扩展(E)</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td>mod_authn_dbd</td></tr>
</table>
    <p><code class="directive">AuthDBDUserRealmPWQuery</code>指定了从数据库中检索一个用户名与认证区域的组合的密码的SQL查询语句。该查询语句必须接受两个单独的字符串(通常是SQL里的varchar类型)参数(username, realm)，同时返回一个单独的字符串值(hash过的密码)。</p>
    <div class="example"><p><code>AuthDBDUserRealmPWQuery "SELECT password FROM authn WHERE username = %s AND realm = %s"</code></p></div>


</div>
</div>
<div id="footer">
<p class="apache">本文允许自由的转载、引用、再分发，但必须保留译者署名并注明出处；详见：<a href="../translator_announcement.html#announcement">版权声明</a>。</p>
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p></div>
</body></html>
